// sampdll.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "sampdll.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}


int WINAPI Foo ( int nIndex )
{
	int x=2;
	//x = x / 0;
	return nIndex;
}

int WINAPI FooRef ( int *nIndex )
{
	//since nIndex holds a pointer we
	//use the * to reference the value.
  	*nIndex += 10;
	return *nIndex + 5;
}

BSTR WINAPI UpperCaseByRef(BSTR *pbstrOriginal)
{
     BSTR bstrUpperCase;
     int i;
     int cbOriginalLen;
     LPSTR strSrcByRef, strDst;

     cbOriginalLen = SysStringByteLen(*pbstrOriginal);
     bstrUpperCase = SysAllocStringByteLen(NULL, cbOriginalLen);
     strSrcByRef = (LPSTR)*pbstrOriginal;
     strDst = (LPSTR)bstrUpperCase;
     for(i=0; i<=cbOriginalLen; i++)
     *strDst++ = toupper(*strSrcByRef++);
     cbOriginalLen = SysStringByteLen(bstrUpperCase);
     return bstrUpperCase;
}

int WINAPI EnumFontFamProc(LOGFONT *lpNLF, NEWTEXTMETRIC *lpNTM, DWORD FontType, LPARAM LParam)
{
	SendMessage((HWND) LParam,LB_ADDSTRING,-1,(LONG) lpNLF->lfFaceName);
    return 1;
}

void WINAPI FillListWithFonts(HWND LB)
{
    HDC hDC = GetDC(LB);
     
	SendMessage(LB,LB_RESETCONTENT,0,0L);
    EnumFontFamilies (hDC, NULL, (FONTENUMPROC) EnumFontFamProc, (LONG) LB);
    ReleaseDC (LB, hDC);
}

CHAR WINAPI RunEXE(HWND hwnd, LPSTR szSrcDir, LPSTR szSupport, LPSTR szInst, LPSTR szRes)
{
	HKEY hKey=0;
	DWORD	type;
	DWORD	cbData=1024;
	char	data[1024];

	//get the reg setting
	RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\mysoftware",0,0,&hKey);
	if (hKey)
	{
		RegQueryValueEx(hKey,"EXE",0,&type,(LPBYTE)data,&cbData);
		data[cbData]=0;
		RegCloseKey(hKey);
		//exec it
		if (32 < WinExec(data,SW_SHOW))
			return 1;
	}
	return 0;
}

//#include <windows.h>
//#include <ole2.h>
#define MAXSIZE 11

#define CCONV _stdcall
#define NOMANGLE

typedef struct
{
     short intgr;     //integer
     long lng;          //long
     float sng;          //single
     double dbl;          //double
     LARGE_INTEGER cur;          //currency
     double dtm;          //date
     short bln;          //boolean
     BYTE byt;          //byte
     VARIANT vnt;          //variant
     BSTR vstrg;          //variable length string
     char strg[MAXSIZE];     //fixed length string
     short array[1][1][2];     //array of integers (2 Bytes in VB)
} UDT;

UDT WINAPI CopyUDT(UDT *pUdt)
{
     UDT udtRet;
     int i, cbLen;
     LPSTR strSrc;
     int cbOriginalLen;
	 int	s;

	 s=sizeof(udtRet);
	 s=sizeof(udtRet.vnt);
	 s=sizeof(udtRet.vstrg);

     // Copy Passed-in UDT into the UDT that has to be returned
     udtRet.intgr = pUdt->intgr;
     udtRet.cur = pUdt->cur;
     udtRet.lng = pUdt->lng;
     udtRet.sng = pUdt->sng;
     udtRet.dbl = pUdt->dbl;
     udtRet.dtm = pUdt->dtm;
     udtRet.bln = pUdt->bln;
     udtRet.byt = pUdt->byt;
     udtRet.array[0][0][0] = pUdt->array[0][0][0];
     cbOriginalLen = SysStringByteLen(pUdt->vstrg);
     udtRet.vstrg = SysAllocStringByteLen((const char *)pUdt->vstrg, cbOriginalLen);

     // must initialize all Variants
     VariantInit(&udtRet.vnt);        
     VariantCopy(&udtRet.vnt, &pUdt->vnt);

     strncpy(udtRet.strg, pUdt->strg, MAXSIZE-1);
    
     // Modify members of passed-in UDT
     cbLen = SysStringByteLen(pUdt->vstrg);
     strSrc = (LPSTR)pUdt->vstrg;
     for(i=0; i<cbLen; i++)
          *strSrc++ = toupper(*strSrc);
    
     pUdt->array[0][0][0]++;
     VariantChangeType(&pUdt->vnt, &pUdt->vnt, NULL, VT_BSTR);

     pUdt->intgr++;
     pUdt->lng++;
     pUdt->sng += (float)1.99;
     pUdt->dbl += 1.99;
     pUdt->cur.LowPart += 1999;
//     pUdt->dtm++;
     pUdt->bln = ~pUdt->bln;
     pUdt->byt = toupper(pUdt->byt);
     strncpy(pUdt->strg, "Bill", MAXSIZE-1);
     return udtRet;
}

short WINAPI VariantArg(VARIANT vt)
{   
     int i;
     char *pcBuf;
     if (vt.vt == VT_DISPATCH)     // variant is an object
          return -1;
     else if (vt.vt == VT_BSTR) 
     {     // variant is a string
          i = SysStringLen(vt.bstrVal);
          pcBuf = (char *)malloc(i + 1);
          WideCharToMultiByte(CP_ACP, 0, vt.bstrVal, i, pcBuf, i, NULL, NULL);
          i = atoi(pcBuf);
          free(pcBuf);
          return (short)i;
     }
     else if (vt.vt == VT_I2)     // variant is an integer
          return vt.iVal;
     else     // variant is something else
          return -3;
}

VARIANT WINAPI CopyArray(LPSAFEARRAY FAR *ppsa)
{
     VARIANT vnt;
	 SAFEARRAY	sa2;
	 LPSAFEARRAY	lpsa2=&sa2;

     BSTR element = NULL;
     long rgIndices[] = {0,1,2};
     // Must initialize variant first
     VariantInit(&vnt);        

     // copy the passed-in array to the array to be returned in
     // variant
     SafeArrayCopy (*ppsa, &lpsa2);
     // Get the value of the string element at (0,1,2). This will
     // be an ANSI string.
     SafeArrayGetElement (lpsa2, rgIndices, &element);

     // Convert this to Unicode, as VB4 (32-bit) will not do
     // so for you, as the string is inside an array *NEWLY
     // CREATED* inside the DLL!
     unsigned int length = SysStringByteLen(element);
     BSTR wcElement = NULL;

     wcElement = SysAllocStringLen(NULL, length*2);
     MultiByteToWideChar(CP_ACP,MB_PRECOMPOSED,(LPCSTR)element,-1, (LPWSTR)wcElement, length*2);

     // Put this Unicode string back into the corresponding
     // location in the array to be returned
     SafeArrayPutElement (lpsa2, rgIndices, wcElement); 
     SysFreeString (wcElement);
     SysFreeString (element);
     element = SysAllocString((BSTR)"Hello Again!");

     // Modify the same element (0,1,2) of the passed-in array
     SafeArrayPutElement (*ppsa, rgIndices, element);
     SysFreeString (element);

     // store the array to be returned in a variant
     vnt.vt = VT_ARRAY|VT_BYREF|VT_BSTR;
     vnt.pparray = &lpsa2;

     return vnt;
}
