//bcCon.h


// declaration needed in all .c files
extern BYTE    bcwinmajor;							//major win number
extern BYTE    bcwinminor;							//minor win number

//movement cursors
#define IDCUR_VSEP      10200
#define IDCUR_HSEP      10201
#define IDCUR_MOVE      10202
#define IDCUR_TLSEP     10203
#define IDCUR_TRSEP     10204

//Defines for the license dialog
#define IDD_LICDIALOG1     5219
#define IDC_LICFRAME       1000
#define IDC_LICSTATIC      1001
#define IDB_LOGO           1002

extern HCURSOR hcurVSep;
extern HCURSOR hcurArrow;
extern HCURSOR hcurHSep;
extern HCURSOR hcurMove;
extern HCURSOR hcurWait;
extern HCURSOR hcurTLSep;
extern HCURSOR hcurTRSep;

//help file define
#define BC_STR_HELP                     "olevbref.hlp"

//custom window message definitions
#define BC_USER				WM_USER + 140
#define WM_SYSTIMER         0x0118
#define BC_TIMER            BC_USER + 1
#define BC_MOUSEMOVE        BC_USER + 2
#define BC_RECREATESTYLE    BC_USER + 3
#define BC_RESIZE           BC_USER + 4
#define BC_ACTIVATE         BC_USER + 5
#define BC_DEACTIVATE       BC_USER + 6
#define BC_SETMAXSIZE       BC_USER + 7
#define BC_CHILDREPAINT     BC_USER + 8
#define BC_POPUPMENU        BC_USER + 9
#define BC_SAVERCANCELLED   BC_USER + 10
#define BC_CHANGE           BC_USER + 11
#define BC_PLAYEND          BC_USER + 12
#define BC_CLOSE            BC_USER + 13
#define BC_QUERYACTIVATE    BC_USER + 14
#define BC_CHANGESTYLE      BC_USER + 15
#define BC_KEYBOARDHOOK     BC_USER + 16
#define BC_GETMESSAGEHOOK   BC_USER + 17
#define BC_SETCURSORSIZE    BC_USER + 18
#define BC_OPENDLG     		BC_USER + 19
#define BC_RECREATECONTROL	BC_USER + 20
//postions 21 through 41 reserved for data access
#define BC_GETDATALEN		BC_USER + 22
#define BC_NCPAINT			BC_USER + 42
#define BC_CLICK			BC_USER + 43
#define BC_DBLCLICK			BC_USER + 44
#define BC_MINIMIZE			BC_USER + 50
#define BC_MAXIMIZE			BC_USER + 51
#define BC_RESTORE			BC_USER + 52
#define BC_MOUSEENTER		BC_USER + 53
#define BC_MOUSELEAVE		BC_USER + 54
#define BC_WAITLOAD			BC_USER + 55


//we use this message for several things, but have no
//idea what it is
#define BC_DONTKNOW        0x1054
#define BC_TWILIGHTZONE    0x1054

//Error message definitions
#define IDS_WRITEONLY           32001
#define IDS_INVALIDWHEN         32002
#define IDS_NOFEATURE	    	32003
#define IDS_CANTREMOVEITEM      32004
#define IDS_INCOMPLETELIST      32005
#define IDS_INVALIDPATH         32259

#define BCTS_INVALIDPATH        "Invalid Path"
#define BCTS_INCOMPLETELIST     "Partial List Loaded"
#define BCTS_MUSTBEVISIBLE		"Item must be visible to be expanded"

