//trnclr.h - include file for trnclr.c

#define VBCOLOR_SCROLLBAR 		0x80000000		// Scroll-bars gray area.
#define VBCOLOR_BACKGROUND 		0x80000001     // Desktop.
#define VBCOLOR_ACTIVECAPTION 	0x80000002		// Active Window Caption.
#define VBCOLOR_INACTIVECAPTION 0x80000003     	// Inactive window caption.
#define VBCOLOR_MENU 			0x80000004     	// Menu background.
#define VBCOLOR_WINDOW 			0x80000005     	// Window background.
#define VBCOLOR_WINDOWFRAME 	0x80000006     	// Window frame.
#define VBCOLOR_MENUTEXT 		0x80000007     	// Text in menus.
#define VBCOLOR_WINDOWTEXT 		0x80000008     	// Text in windows.
#define VBCOLOR_CAPTIONTEXT 	0x80000009     	// Text in caption, size box, scroll-bar arrow box..
#define VBCOLOR_ACTIVEBORDER 	0x8000000A     	// Active window border.
#define VBCOLOR_INACTIVEBORDER 	0x8000000B     	// Inactive window border.
#define VBCOLOR_APPWORKSPACE 	0x8000000C     	// Background color of multiple document interface (MDI) applications.
#define VBCOLOR_HIGHLIGHT 		0x8000000D     	// Items selected item in a control.
#define VBCOLOR_HIGHLIGHTTEXT 	0x8000000E     	// Text of item selected in a control.
#define VBCOLOR_BTNFACE 		0x8000000F     	// Face shading on command buttons.
#define VBCOLOR_BTNSHADOW 		0x80000010     	// Edge shading on command buttons.
#define VBCOLOR_GRAYTEXT 		0x80000011     	// Grayed (disabled) text.  This color is set to 0 if the current display driver does not support a solid gray color.
#define VBCOLOR_BTNTEXT 		0x80000012     	// Text on push buttons.

EXTERN_C LONG PASCAL GizmosVBTranslateColor
(
	LONG Color
);

EXTERN_C LONG PASCAL GizmosGetVBSysColors
(
	LONG 	Color
);
