//chap5.cpp
#include "stdafx.h"
#include"chap5.h"

Circle::Circle(Circle &cir)
{
  x=cir.GetCenterX();
  y=cir.GetCenterY();
  r=cir.GetRadius();
}

Circle::Circle(RECT &rt)
{
  x=rt.left + ((rt.right-rt.left)/2);
  y=rt.top + ((rt.bottom-rt.top)/2);
  r=((rt.bottom-rt.top)/2);
}

void Circle::SetCenter(int xr, int yr)
{
  x = xr;
  y = yr;
}
void Circle::SetRadius(int rr)
{
  r = rr;
}

int Circle::GetCenterX()
{
  return x;
}

int Circle::GetCenterY()
{
  return y;
}

int Circle::GetRadius()
{
  return r;
}

Circle &Circle::operator=( Circle &cir )
{
  x = cir.GetCenterX();
  y = cir.GetCenterY();
  r = cir.GetRadius();
  return *this;
}

Circle &Circle::operator=( RECT &rt )
{
  x=rt.left + ((rt.right-rt.left)/2);
  y=rt.top + ((rt.bottom-rt.top)/2);
  r=((rt.bottom-rt.top)/2);
  return *this;
}

