//chap5.cpp
#include "stdafx.h"
#include"chap5.h"
Circle::Circle(Circle &cir)
{
       x=cir.GetCenterX();
       y=cir.GetCenterY();
       r=cir.GetRadius();
}

Circle::Circle(RECT &rt)
{
       x=rt.left + ((rt.right-rt.left)/2);
       y=rt.top + ((rt.bottom-rt.top)/2);
       r=((rt.bottom-rt.top)/2);
}

void Circle::SetCenter(int xr, int yr)
{
       x = xr;
       y = yr;
}
void Circle::SetRadius(int rr)
{
       r = rr;
}

int Circle::GetCenterX()
{
       return x;
}

int Circle::GetCenterY()
{
       return y;
}

int Circle::GetRadius()
{
       return r;
}

Circle &Circle::operator=( Circle &cir )
{
    x = cir.GetCenterX();
    y = cir.GetCenterY();
       r = cir.GetRadius();
    return *this;
}

Circle &Circle::operator=( RECT &rt )
{
       x=rt.left + ((rt.right-rt.left)/2);
       y=rt.top + ((rt.bottom-rt.top)/2);
       r=((rt.bottom-rt.top)/2);
    return *this;
}

void Circle::Draw(HDC hdc)
{
       HPEN linePen;
       HPEN oldPen;

       linePen = ::CreatePen(PS_SOLID,1,lineColor);
       oldPen = (HPEN) ::SelectObject(hdc, linePen);
       ::Ellipse(hdc, x-r,y-r,x+r,y+r);
       ::SelectObject(hdc, oldPen);
       ::DeleteObject(linePen);
}


//the draw function is an override of the base class
//implementation of the Draw function.
void ArcPie::Draw(HDC hdc)
{
       HPEN linePen;
       HPEN oldPen;
       HBRUSH fillBrush;
       HBRUSH oldBrush;

       fillBrush = ::CreateSolidBrush(fillColor);
       linePen = ::CreatePen(PS_SOLID,1,lineColor);
       oldPen = (HPEN) ::SelectObject(hdc, linePen);
       ::MoveToEx(hdc, x,y,NULL);
       ::BeginPath(hdc);
       oldBrush = (HBRUSH) ::SelectObject(hdc, fillBrush);

       ::AngleArc(hdc, x,y,(DWORD)r,start,sweep);
       ::LineTo(hdc, x, y);
       ::EndPath(hdc);
       ::StrokeAndFillPath(hdc);
       ::SelectObject(hdc, oldPen);
       ::DeleteObject(linePen);
       ::SelectObject(hdc, oldBrush);
       ::DeleteObject(fillBrush);
}
