//3dtext.h - include file for 3dtext.c

//draws 3d text effects

//	HDC		hdc,		hdc to draw on
//	LPSTR	lpmem,		far pointer to the text
//	SHORT	tlength,	length of the text (-1 for 0 delimited)
//	LPRECT	lprect,		rectangle to draw within
//	WORD	wFormat,	format flags (see drawtext help)
//	SHORT	style,		(0 - none, 1-raised, 2-more raised, 3-lowered, 4-lowered more)
//	LONG	textcolor,	color for text
//	LONG	lightcolor,	color for light
//	LONG	shadowcolor	color for shadow

EXTERN_C void PASCAL GizmosDraw3dText
(
	HDC		hdc,
	LPSTR	lpmem,
	SHORT	tlength,
	LPRECT	lprect,
	WORD	wFormat,
	SHORT	style,
	LONG	textcolor,
	LONG	lightcolor,
	LONG	shadowcolor
);
                
EXTERN_C void FAR PASCAL GizmosDrawRotated3dText
(
	HDC		hdc,
	LPSTR	lpmem,
	SHORT	tlength,
	LPRECT	lprect,
	WORD	wFormat,
	SHORT	style,
	LONG	textcolor,
	LONG	lightcolor,
	LONG	shadowcolor,
	int		rotationamount
);

